#include "../../plugin.hpp"

enum {
  mName,
  mMessage,
};

#define FAR165_INFO_SIZE 336

PluginStartupInfo Info;
FARSTANDARDFUNCTIONS FSF;
bool IsOldFAR=true;

const char *GetMsg(int MsgId)
{
  return(Info.GetMsg(Info.ModuleNumber,MsgId));
}

void WINAPI SetStartupInfo(const struct PluginStartupInfo *Info)
{
  memset(&::Info,0,sizeof(::Info));
  memmove(&::Info,Info,(Info->StructSize>(int)sizeof(::Info))?sizeof(::Info):Info->StructSize);
  if(Info->StructSize>FAR165_INFO_SIZE)
  {
    IsOldFAR=false;
    ::FSF=*Info->FSF;
    ::Info.FSF=&::FSF;
  }
}

void WINAPI GetPluginInfo(struct PluginInfo *Info)
{
  if(!IsOldFAR)
  {
    static const char *PluginMenuStrings;
    memset(Info,0,sizeof(*Info));
    Info->Flags=PF_EDITOR|PF_VIEWER|PF_DISABLEPANELS;
    Info->StructSize=sizeof(*Info);
    Info->PluginMenuStringsNumber=1;
    PluginMenuStrings=GetMsg(mName);
    Info->PluginConfigStrings=&PluginMenuStrings;
    Info->PluginMenuStrings=&PluginMenuStrings;
  }
}

int WINAPI _export GetMinFarVersion(void)
{
  return FARMANAGERVERSION;
}

HANDLE WINAPI OpenPlugin(int OpenFrom,int Item)
{
  if((OpenFrom==OPEN_EDITOR)||(OpenFrom==OPEN_VIEWER))
  {
    Info.Viewer("nul",GetMsg(mMessage),0,0,-1,-1,VF_NONMODAL);
  }
  return INVALID_HANDLE_VALUE;
}

#ifdef __cplusplus
extern "C"{
#endif
  bool WINAPI DllMainCRTStartup(HANDLE hDll,DWORD dwReason,LPVOID lpReserved);
#ifdef __cplusplus
};
#endif

bool WINAPI DllMainCRTStartup(HANDLE hDll,DWORD dwReason,LPVOID lpReserved)
{
  return true;
}
